# Copyright (C) 1991-2009 Altera Corporation
# Your use of Altera Corporation's design tools, logic functions 
# and other software and tools, and its AMPP partner logic 
# functions, and any output files from any of the foregoing 
# (including device programming or simulation files), and any 
# associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License 
# Subscription Agreement, Altera MegaCore Function License 
# Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the 
# applicable agreement for further details.

# Quartus II: Generate Tcl File for Project
# File: DE1_NIOS.tcl
# Generated on: Wed Jul 29 16:51:58 2015

# Load Quartus II Tcl Project package
package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "DE1_NIOS"]} {
		puts "Project DE1_NIOS is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists DE1_NIOS]} {
		project_open -revision DE1_NIOS DE1_NIOS
	} else {
		project_new -revision DE1_NIOS DE1_NIOS
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
	set_global_assignment -name FAMILY "Cyclone II"
	set_global_assignment -name DEVICE EP2C8Q208C8
	set_global_assignment -name ORIGINAL_QUARTUS_VERSION "5.1 SP2"
	set_global_assignment -name PROJECT_CREATION_TIME_DATE "14:25:28  APRIL 24, 2006"
	set_global_assignment -name LAST_QUARTUS_VERSION 9.1
	set_global_assignment -name VERILOG_FILE cpu_0.v
	set_global_assignment -name VERILOG_FILE cpu_0_jtag_debug_module.v
	set_global_assignment -name VERILOG_FILE cpu_0_jtag_debug_module_wrapper.v
	set_global_assignment -name VERILOG_FILE cpu_0_mult_cell.v
	set_global_assignment -name VERILOG_FILE cpu_0_test_bench.v
	set_global_assignment -name VERILOG_FILE DE1_NIOS.v
	set_global_assignment -name VERILOG_FILE epcs_controller.v
	set_global_assignment -name VERILOG_FILE jtag_uart_0.v
	set_global_assignment -name VERILOG_FILE KEY.v
	set_global_assignment -name VERILOG_FILE LEDG.v
	set_global_assignment -name VERILOG_FILE LEDR.v
	set_global_assignment -name VERILOG_FILE Reset_Delay.v
	set_global_assignment -name VERILOG_FILE sdram_0.v
	set_global_assignment -name VERILOG_FILE sdram_0_test_component.v
	set_global_assignment -name VERILOG_FILE SDRAM_PLL.v
	set_global_assignment -name VERILOG_FILE SEG7.v
	set_global_assignment -name VERILOG_FILE SEG7_LUT.v
	set_global_assignment -name VERILOG_FILE SEG7_LUT_4.v
	set_global_assignment -name VERILOG_FILE sram_0.v
	set_global_assignment -name VERILOG_FILE SRAM_16Bit_512K.v
	set_global_assignment -name VERILOG_FILE Switch.v
	set_global_assignment -name QUARTUS_PTF_FILE system_0.ptf
	set_global_assignment -name VERILOG_FILE system_0.v
	set_global_assignment -name VERILOG_FILE uart_0.v
	set_global_assignment -name VERILOG_FILE user_logic_SRAM_16Bits_512K_0.v
	set_global_assignment -name LL_ROOT_REGION ON -section_id "Root Region"
	set_global_assignment -name LL_MEMBER_STATE LOCKED -section_id "Root Region"
	set_global_assignment -name QIP_FILE system_0.qip
	set_global_assignment -name STRATIX_DEVICE_IO_STANDARD "3.3-V LVTTL"
	set_global_assignment -name MISC_FILE "E:/fpga/DE1_NIOS/DE1_NIOS.dpf"
	set_global_assignment -name STRATIX_CONFIGURATION_DEVICE EPCS4
	set_global_assignment -name ON_CHIP_BITSTREAM_DECOMPRESSION OFF
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS "AS INPUT TRI-STATED"
	set_global_assignment -name CYCLONEII_RESERVE_NCEO_AFTER_CONFIGURATION "USE AS REGULAR IO"
	set_global_assignment -name RESERVE_ASDO_AFTER_CONFIGURATION "AS INPUT TRI-STATED"
	set_global_assignment -name QIP_FILE SDRAM_PLL.qip
	set_global_assignment -name MIN_CORE_JUNCTION_TEMP 0
	set_global_assignment -name MAX_CORE_JUNCTION_TEMP 85
	set_global_assignment -name USE_CONFIGURATION_DEVICE ON
	set_global_assignment -name MISC_FILE "G:/FPGA_PRJ/my_nios_729/vga_nios_729/DE1_NIOS/DE1_NIOS.dpf"
    
    
    

	set_location_assignment pin_23 -to CLOCK_50


	set_location_assignment PIN_151 -to VGA_R
	set_location_assignment PIN_150 -to VGA_G
	set_location_assignment PIN_149 -to VGA_B
	set_location_assignment PIN_152 -to VGA_HS
	set_location_assignment PIN_161 -to VGA_VS

#SDRAM_PIN	
	set_location_assignment PIN_201 -to DRAM_ADDR[0]
	set_location_assignment PIN_200 -to DRAM_ADDR[1]
	set_location_assignment PIN_199 -to DRAM_ADDR[2]
	set_location_assignment PIN_198 -to DRAM_ADDR[3]
	set_location_assignment PIN_170 -to DRAM_ADDR[4]
	set_location_assignment PIN_171 -to DRAM_ADDR[5]
	set_location_assignment PIN_173 -to DRAM_ADDR[6]
	set_location_assignment PIN_175 -to DRAM_ADDR[7]
	set_location_assignment PIN_176 -to DRAM_ADDR[8]
	set_location_assignment PIN_179 -to DRAM_ADDR[9]
	set_location_assignment PIN_203 -to DRAM_ADDR[10]
	set_location_assignment PIN_180 -to DRAM_ADDR[11]
	set_location_assignment PIN_169 -to DRAM_ADDR[12]
	set_location_assignment PIN_206 -to DRAM_BA_0
	set_location_assignment PIN_205 -to DRAM_BA_1
	set_location_assignment PIN_168 -to DRAM_CAS_N
	set_location_assignment PIN_181 -to DRAM_CKE
	set_location_assignment PIN_182 -to DRAM_CLK
	set_location_assignment PIN_207 -to DRAM_CS_N
	set_location_assignment PIN_15 -to DRAM_DQ[0]
	set_location_assignment PIN_14 -to DRAM_DQ[1]
	set_location_assignment PIN_13 -to DRAM_DQ[2]
	set_location_assignment PIN_12 -to DRAM_DQ[3]
	set_location_assignment PIN_11 -to DRAM_DQ[4]
	set_location_assignment PIN_10 -to DRAM_DQ[5]
	set_location_assignment PIN_8 -to DRAM_DQ[6]
	set_location_assignment PIN_6 -to DRAM_DQ[7]
	set_location_assignment PIN_187 -to DRAM_DQ[8]
	set_location_assignment PIN_188 -to DRAM_DQ[9]
	set_location_assignment PIN_189 -to DRAM_DQ[10]
	set_location_assignment PIN_191 -to DRAM_DQ[11]
	set_location_assignment PIN_192 -to DRAM_DQ[12]
	set_location_assignment PIN_193 -to DRAM_DQ[13]
	set_location_assignment PIN_195 -to DRAM_DQ[14]
	set_location_assignment PIN_197 -to DRAM_DQ[15]
	
	set_location_assignment PIN_5 -to DRAM_LDQM
	set_location_assignment PIN_208 -to DRAM_RAS_N
	set_location_assignment PIN_185 -to DRAM_UDQM
	set_location_assignment PIN_3 -to DRAM_WE_N
	
#FLAH_PIN		
#	set_location_assignment PIN_64 -to FL_ADDR[0]
#	set_location_assignment PIN_31 -to FL_ADDR[1]
#	set_location_assignment PIN_33 -to FL_ADDR[2]
#	set_location_assignment PIN_34 -to FL_ADDR[3]
#	set_location_assignment PIN_35 -to FL_ADDR[4]
#	set_location_assignment PIN_37 -to FL_ADDR[5]
#	set_location_assignment PIN_39 -to FL_ADDR[6]
#	set_location_assignment PIN_40 -to FL_ADDR[7]
#	set_location_assignment PIN_47 -to FL_ADDR[8]
#	set_location_assignment PIN_48 -to FL_ADDR[9]
#	set_location_assignment PIN_61 -to FL_ADDR[10]
#	set_location_assignment PIN_60 -to FL_ADDR[11]
#	set_location_assignment PIN_59 -to FL_ADDR[12]
#	set_location_assignment PIN_58 -to FL_ADDR[13]
#	set_location_assignment PIN_57 -to FL_ADDR[14]
#	set_location_assignment PIN_56 -to FL_ADDR[15]
#	set_location_assignment PIN_92 -to FL_ADDR[16]
#	set_location_assignment PIN_41 -to FL_ADDR[17]
#	set_location_assignment PIN_43 -to FL_ADDR[18]
#	set_location_assignment PIN_46 -to FL_ADDR[19]
#	set_location_assignment PIN_45 -to FL_ADDR[20]
#	
#	//set_location_assignment PIN_R13 -to FL_ADDR[21]
#	
#	set_location_assignment PIN_69 -to FL_DQ[0]
#	set_location_assignment PIN_72 -to FL_DQ[1]
#	set_location_assignment PIN_75 -to FL_DQ[2]
#	set_location_assignment PIN_77 -to FL_DQ[3]
#	set_location_assignment PIN_81 -to FL_DQ[4]
#	set_location_assignment PIN_84 -to FL_DQ[5]
#	set_location_assignment PIN_87 -to FL_DQ[6]
#	set_location_assignment PIN_89 -to FL_DQ[7]
#	set_location_assignment PIN_70 -to FL_DQ[8]
#	set_location_assignment PIN_74 -to FL_DQ[9]
#	set_location_assignment PIN_76 -to FL_DQ[10]
#	set_location_assignment PIN_80 -to FL_DQ[11]
#	set_location_assignment PIN_82 -to FL_DQ[12]
#	set_location_assignment PIN_86 -to FL_DQ[13]
#	set_location_assignment PIN_88 -to FL_DQ[14]
#	set_location_assignment PIN_90 -to FL_DQ[15]
#	
#	set_location_assignment PIN_68 -to FL_OE_N
#	set_location_assignment PIN_44 -to FL_WE_N
#    set_location_assignment PIN_67 -to   FL_CE_N
#	
#SRAM_PIN		
	set_location_assignment PIN_64 -to SRAM_ADDR[0]
	set_location_assignment PIN_31 -to SRAM_ADDR[1]
	set_location_assignment PIN_33 -to SRAM_ADDR[2]
	set_location_assignment PIN_34 -to SRAM_ADDR[3]
	set_location_assignment PIN_35 -to SRAM_ADDR[4]
	set_location_assignment PIN_37 -to SRAM_ADDR[5]
	set_location_assignment PIN_39 -to SRAM_ADDR[6]
	set_location_assignment PIN_40 -to SRAM_ADDR[7]
	set_location_assignment PIN_47 -to SRAM_ADDR[8]
	set_location_assignment PIN_48 -to SRAM_ADDR[9]
	set_location_assignment PIN_61 -to SRAM_ADDR[10]
	set_location_assignment PIN_60 -to SRAM_ADDR[11]
	set_location_assignment PIN_59 -to SRAM_ADDR[12]
	set_location_assignment PIN_58 -to SRAM_ADDR[13]
	set_location_assignment PIN_57 -to SRAM_ADDR[14]
	set_location_assignment PIN_56 -to SRAM_ADDR[15]
	set_location_assignment PIN_92 -to SRAM_ADDR[16]
	set_location_assignment PIN_41 -to SRAM_ADDR[17]
	set_location_assignment PIN_43 -to SRAM_ADDR[18]

	
	set_location_assignment PIN_69 -to SRAM_DQ[0]
	set_location_assignment PIN_72 -to SRAM_DQ[1]
	set_location_assignment PIN_75 -to SRAM_DQ[2]
	set_location_assignment PIN_77 -to SRAM_DQ[3]
	set_location_assignment PIN_81 -to SRAM_DQ[4]
	set_location_assignment PIN_84 -to SRAM_DQ[5]
	set_location_assignment PIN_87 -to SRAM_DQ[6]
	set_location_assignment PIN_89 -to SRAM_DQ[7]
	set_location_assignment PIN_70 -to SRAM_DQ[8]
	set_location_assignment PIN_74 -to SRAM_DQ[9]
	set_location_assignment PIN_76 -to SRAM_DQ[10]
	set_location_assignment PIN_80 -to SRAM_DQ[11]
	set_location_assignment PIN_82 -to SRAM_DQ[12]
	set_location_assignment PIN_86 -to SRAM_DQ[13]
	set_location_assignment PIN_88 -to SRAM_DQ[14]
	set_location_assignment PIN_90 -to SRAM_DQ[15]
	
	set_location_assignment PIN_99 -to SRAM_CE_N
	set_location_assignment PIN_97 -to SRAM_WE_N
	set_location_assignment PIN_96 -to SRAM_OE_N
	set_location_assignment PIN_95 -to SRAM_UB_N
	set_location_assignment PIN_94 -to SRAM_LB_N
    
#PS2
 	set_location_assignment PIN_165 -to PS2_CLK
    set_location_assignment PIN_147 -to  PS2_DAT
#BUZZER
     set_location_assignment PIN_30 -to BUZZER   
	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}
